local frame = CreateFrame("EditBox")
local rawLink = nil
local wowheadLink = nil

-- generating link
local function setTooltipHyperlink(tooltip, link)
    rawLink = link

    local parts = { strsplit(":", rawLink) }
    wowheadLink = "http://www.wowhead.com/item="..parts[2].."&bonus="..parts[15]..":"..parts[16]
end

-- hooks
local function onEvent(frame, event)
    if event == "PLAYER_ENTERING_WORLD" then
        hooksecurefunc(ItemRefTooltip, "SetHyperlink", setTooltipHyperlink)
    end
end

local function onUpdate()
    StaticPopup_Show("WOWHEAD_LINK_GENERATOR")
    frame:Hide();
end

-- keybind action
local function showFrame()
    if wowheadLink == nil then
        return false
    end

    frame:Show();
    return true
end

openFrame = function()
    return showFrame()
end

-- frame
frame:Hide()
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", onEvent)
frame:SetScript("OnUpdate", onUpdate)

BINDING_HEADER_WOWHEAD_LINK_GENERATOR = "Wowhead Link Generator";
BINDING_NAME_WOWHEAD_LINK_GENERATE = "Open Wowhead link window"

StaticPopupDialogs["WOWHEAD_LINK_GENERATOR"] = {
    OnShow = function (self)
        self.editBox:SetScript("OnEscapePressed", function(self) 
            self:GetParent():Hide() 
        end)
    end,

    OnUpdate = function(self, elapsed)
        self.editBox:SetText(wowheadLink)
        self.editBox:HighlightText()
    end,

    button1 = OKAY,
    editBoxWidth = 350,
    hasEditBox=true,
    preferredIndex = 3
}

StaticPopupDialogs["WOWHEAD_LINK_GENERATOR"].text = "Generated Wowhead Link"
